<script lang="ts" setup>
import { ChevronLgLeft, ChevronLgRight } from 'slippers-ui/icons';

interface TimelineProps {
  title: string;
  items: Array<{
    text: string;
    year: number;
  }>;
}

defineProps<TimelineProps>();

const timelineRow = ref<HTMLElement | null>(null);
const isAtStart = ref(true);
const isAtEnd = ref(false);

const checkPosition = () => {
  if (!timelineRow.value?.$el) return;

  const element = timelineRow.value.$el;
  isAtStart.value = element.scrollLeft <= 0;
  isAtEnd.value = Math.ceil(element.scrollLeft + element.offsetWidth) >= element.scrollWidth;
};

const handleScroll = () => {
  checkPosition();
};

const handleScrollNext = async () => {
  if (!timelineRow.value?.$el) return;
  const content = timelineRow.value.$el;
  const itemWidth = document.querySelector('.timeline__item')?.offsetWidth || 0;

  await nextTick();
  content.scrollLeft += itemWidth;
  checkPosition();
};

const handleScrollPrev = async () => {
  if (!timelineRow.value?.$el) return;
  const content = timelineRow.value.$el;
  const itemWidth = document.querySelector('.timeline__item')?.offsetWidth || 0;

  await nextTick();
  content.scrollLeft -= itemWidth;
  checkPosition();
};

const onResize = () => {
  checkPosition();
};

onMounted(() => {
  nextTick(() => {
    checkPosition();
    if (timelineRow.value?.$el) {
      timelineRow.value.$el.addEventListener('scroll', handleScroll);
    }
  });
  window.addEventListener('resize', onResize);
});

onUnmounted(() => {
  if (timelineRow.value?.$el) {
    timelineRow.value.$el.removeEventListener('scroll', handleScroll);
  }
  window.removeEventListener('resize', onResize);
});
</script>

<template>
  <SlpSection background-color="$color-surface-700">
    <div class="timeline">
      <SlpContainer>
        <div class="timeline__gradient-header" />
        <SlpTypography variant="heading2-bold" tag="h2" class="slp-mb-64">
          {{ title }}
        </SlpTypography>
        <SlpRow ref="timelineRow" class="timeline__row" :class="{ 'no-shadow': isAtEnd }">
          <SlpColumn
            v-for="item in items"
            :key="item.text"
            :cols="3"
            :class="item.year ? 'timeline__item' : 'timeline__no-year'"
          >
            <SlpTypography variant="heading3-bold" tag="h3" class="timeline__year slp-mt-32 slp-mb-96">
              {{ item.year }}
            </SlpTypography>
            <SlpTypography variant="body1-bold" tag="p">
              {{ item.text }}
            </SlpTypography>
          </SlpColumn>
        </SlpRow>
        <SlpRow>
          <SlpColumn class="slp-mt-64 slp-flex slp-align-items-center timeline__arrow-container">
            <div class="timeline-controls arrows">
              <SlpButton
                id="arrow__prev"
                :class="{ disabled: isAtStart }"
                variant="icon"
                aria-label="View previous item"
                @click="handleScrollPrev"
              >
                <SlpIcon :icon="ChevronLgLeft" color="primary-100" />
              </SlpButton>
              <SlpButton
                id="arrow__next"
                :class="{ disabled: isAtEnd }"
                variant="icon"
                aria-label="View next item"
                @click="handleScrollNext"
              >
                <SlpIcon :icon="ChevronLgRight" color="primary-100" />
              </SlpButton>
            </div>
          </SlpColumn>
        </SlpRow>
      </SlpContainer>
    </div>
  </SlpSection>
</template>

<style lang="scss" scoped>
.timeline {
  padding-top: $spacing-96;
  padding-bottom: $spacing-96;
  color: $color-text-50;
  background-color: $color-surface-700;

  &__gradient-header {
    background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
    height: 4px;
    width: 95px;
    border-radius: 10px;
    margin-bottom: $spacing-16;
  }

  &__row {
    scroll-behavior: smooth;
    flex-wrap: nowrap;
    overflow: hidden;
    transition: all 1s;
    mask-image: linear-gradient(to left, transparent, #171321 40%);
    -webkit-mask-image: linear-gradient(to left, transparent, #171321 40%);

    &.no-shadow {
      mask-image: none;
      -webkit-mask-image: none;
    }
  }

  &__item {
    transition: all 1s;
    padding: $spacing-16;
    border-left: 1px solid $color-surface-50;
    will-change: transform;
    min-width: 200px;
  }

  &__no-year {
    position: relative;
    padding: $spacing-16;
    min-width: 200px;

    &:before {
      content: '';
      width: 1px;
      height: 200px;
      background-color: $color-surface-50;
      position: absolute;
      left: 0;
      bottom: 0;
    }
  }

  .slp-btn.disabled {
    pointer-events: none;
    opacity: 0.5;
  }

  &__year {
    background: linear-gradient(90deg, #ef8cf3 0%, #825ee9 35%);
    -webkit-background-clip: text;
    -webkit-text-fill-color: transparent;
    background-clip: text;
    height: 48px;
  }

  &__arrow-container {
    justify-content: flex-end;
  }
}
</style>
